#ifndef LR1_PROBLEM_H
#define LR1_PROBLEM_H

#define DEBUG 1
#define OUTPUT2FILE 0

#ifdef __cplusplus
extern "C" {
#endif

class lr1_problem
{
	public:
		lr1_problem(const struct problem *prob, const struct problem *prob_t, double Cp, double Cn);
		~lr1_problem();

		double func(double *w, double *z);
		void grad(double *z, double *g, double *D);
		double grad_condiction(double *g, double *w);
		void Hv(double *D, double *s, double *Hs); 
		void subHv(int len, int *ind, double *D, double *s, double *Hs);
		double testing(double *w);

		int l, n;
		double gtol, cgtol;
		double maxfev;
		double fmin, fatol, frtol;

	private:
		void Xv(double *v, double *Xv);
		void XTv(double *v, double *XTv);

		double *x_val;
		int *x_jc, *x_ir;
		double *C;
		const struct problem *prob;
		const struct problem *prob_t;
};

class l2svm_problem
{
	public:
		l2svm_problem(const struct problem *prob, const struct problem *prob_t, double Cp, double Cn);
		~l2svm_problem();

		double func(double *w, double *z);
		double grad_condiction(double *g, double *w);
		void grad(double *z, double *g, double *D);
		void Hv(double *D, double *s, double *Hs); 
		void subHv(int len, int *ind, double *D, double *s, double *Hs);
		double testing(double *w);

		int l, n;
		double gtol, cgtol;
		double maxfev;
		double fmin, fatol, frtol;

	private:
		void Xv(double *v, double *Xv);
		void subXv(double *v, double *Xv);
		void subXTv(double *v, double *XTv);

		double *x_val;
		int *x_jc, *x_ir;
		double *C;
		const struct problem *prob;
		const struct problem *prob_t;

		int *I;
		int sizeI;
};

#ifdef __cplusplus
}
#endif

#endif
